# Introduction

Dans cette section, vous allez mettre en place le projet initial :
1. Cliquez sur [ce lien](https://kinolien.github.io/gitzip/?download=https://github.com/andyborrell/pygamezero_bird/tree/master/images) pour télécharger un fichier .zip contenant les images pour le projet, arrangez-vous ensuite pour extraire ce dossier dans la racine de votre projet (ie: dans le dossier paf-loiseau).
2. Créez un script Python de départ nommé `birdie.py`, toujours dans le dossier racine de votre projet. ajouter un simple `print('Hello world !')` dans ce script et enregistez-le.
3. Dans un terminal, exécutez la commande `virtualenv env`, ce qui devrait avoir pour effet de créer un dossier contenant l'environnement virtuel à côté de de votre dossier images et de votre script python.
4. Vérifiez et ajustez au besoin l'interpréteur Python pour qu'il soit celui de votre environnement virtuel (cliquer sur l'interpréteur actuel dans le coin inférieur gauche et sélectionner celui se trouvant dans l'environnement virtuel).

![changement d'interpréteur](https://i.imgur.com/2B5c06Z.png)

5. Refermez et réouvrez votre terminal pour vérifier qu'il utilisez également l'environnement correct.

![terminal sous environnement virtuel](https://i.imgur.com/KabiKPk.png)

6. Dans certains cas, les configurations de vscode spécifiques à votre projet sont mémorisées dans un dossier `.vscode`. Ce dossier est spécifique à la machine utilisée pour le développement, et n'a pas à être suivi par GIT. Arrangez-vous donc pour l'exclure en ajoutant `.vscode/` dans le fichier .gitignore, avant de valider tout autre changement.

7. Pour la suite de ce projet, nous aurons besoin de deux bibliothèques python spécifiques : **pgzero** et **pygame**. La première repose sur la seconde et fourni un accès plus aisé aux fonctionnalités dont nous aurons besoin dans la création de notre jeu. Comme il existe actuellement une incompatibilité de version entre les deux, la marche à suivre pour l'installation est un peu particulière : il faut commencer par installer pygame avec la commande suivante : `pip install pygame`. Ensuite, il faut installer pgzero en lui précisant de ne pas s'occuper de dépendances éventuelles : `pip install --no-deps pgzero`.

## Problèmes possibles et solutions

Sous Windows, l'environnement virtuel est activé automatiquement à l'ouverture du projet à l'aide d'un script PowerShell `activate.ps1` se trouvant dans le dossier `env\Scripts`. Pour des raisons de sécurité et par défaut, Windows empêche l'exécution de tels scripts, provoquant l'erreur du type :

![Erreur de protection d'exécution](https://i.imgur.com/64K4LS4.png)

Il existe principalement deux manière de corriger ce problème :
1. Au niveau global Windows, pour l'utilisateur courant, avec la commande suivante, exécutée dans un PowerShell exécuté et **avec les droits d'adminitrateurs** : `Set-ExecutionPolicy -ExecutionPolicy RemoteSigned -Scope CurrentUser`.
2. Pour les shells ouverts à l'intérieur de vscode seulement, en ajoutant `"terminal.integrated.shellArgs.windows": ["-ExecutionPolicy", "RemoteSigned"]` aux paramètres globaux de vscode :

![Ajusterment de la stratégie d'exécution dans vscode](https://i.imgur.com/ZYQh6CY.gif)


